package com.arubanetworks.meridiansamples;

import com.arubanetworks.meridian.Meridian;
import com.arubanetworks.meridian.editor.EditorKey;
import com.arubanetworks.meridian.internal.util.Dev;

import org.acra.ACRA;
import org.acra.ReportField;
import org.acra.ReportingInteractionMode;
import org.acra.annotation.ReportsCrashes;

@ReportsCrashes(
        mailTo = "developers@meridianapps.com",
        customReportContent = { ReportField.APP_VERSION_CODE, ReportField.APP_VERSION_NAME, ReportField.ANDROID_VERSION, ReportField.PHONE_MODEL, ReportField.CUSTOM_DATA, ReportField.STACK_TRACE, ReportField.LOGCAT },
        mode = ReportingInteractionMode.TOAST,
        resToastText = R.string.issue_report
)
public class Application extends android.app.Application {
    //NOTE: To build the Kotlin Samples App, change the build variant.
    // To build the default Sample SDK App, use:
    public static final EditorKey APP_KEY = EditorKey.forApp("5809862863224832");
    public static final EditorKey MAP_KEY = EditorKey.forMap("5668600916475904", APP_KEY);

    // To build your own customized SDK based App, replace APP_KEY and MAP_KEY with your location's App and Map ID values:
    // public static final EditorKey APP_KEY = EditorKey.forApp("APP_KEY");
    // public static final EditorKey MAP_KEY = EditorKey.forMap("MAP_KEY", APP_KEY);

    // To build the default Sample SDK App for EU Servers, use the following:
    // NOTE: Even if you're geographically located in the EU, you probably won't need to do this.
    // public static final EditorKey APP_KEY = EditorKey.forApp("4856321132199936");
    // public static final EditorKey MAP_KEY = EditorKey.forMap("5752754626625536", APP_KEY);

    public static final String PLACEMARK_UID = "CASIO_UID"; // replace this with a unique id for one of your placemarks.
    public static final String CAMPAIGN_ID = ""; // unique id for one of your campaigns here.
    public static final String TAG_MAC = ""; // mac address of one of your tags here
    // replace this with the correct editor token for the location
    public static final String EDITOR_TOKEN = "eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJ0IjoxNTc5MzAwMjM4LCJ2YWx1ZSI6IjJmOWIwMjY1YmQ2NzZmOTIxNjQ5YTgxNDBlNGZjN2I4YWM0YmYyNTcifQ.pxYOq2oyyudM3ta_bcij4R_hY1r3XG6xIDATYDW4zIk";

    @Override
    public void onCreate() {
        // Configure Meridian
        Meridian.configure(this, EDITOR_TOKEN);

        // Example of setting the Sample App for the EU server
        // Meridian.getShared().setDomainRegion(Meridian.DomainRegion.DomainRegionEU);

        // Example of overriding cache headers
        //Meridian.getShared().setOverrideCacheHeaders(true);
        //Meridian.getShared().setCacheOverrideTimeout(1000*60*60); // 1 hour

        // Example of preventing this app from reporting Analytics if it is in debug mode.
        //Meridian.getShared().setUseAnalytics(!BuildConfig.DEBUG);

        // Example of setting the default picker style.
        //Meridian.getShared().setPickerStyle(LevelPickerControl.PickerStyle.PICKER_SEARCH);

        // Enable support for dark theme within the app like below.
        Meridian.getShared().supportDarkTheme(true);

        // ACRA is for bug reporting in the samples app and is not necessary for the Meridian SDK
        ACRA.init(this);
        ACRA.getErrorReporter().putCustomData("MERIDIAN_SDK", Meridian.getShared().getSDKVersion());
        ACRA.getErrorReporter().putCustomData("MERIDIAN_API", Meridian.getShared().getAPIVersion());
        ACRA.getErrorReporter().putCustomData("MERIDIAN_URL", Meridian.getShared().getAPIBaseUri().toString());

        // Create notification channel for Oreo
        CampaignReceiver.createNotificationChannel(this);
        super.onCreate();
    }
}
